﻿using UnityEngine;
using System.Collections;

public class CamTrollyScript : MonoBehaviour {

	public GameObject Follow;
	float zoomlevel;
	Color sunrise;
	Color sunset;
	float StartTime;
	bool GameIsActive;
	//public GameObject gaia_reference;
	//GaiaScript GS_ref;

	// Use this for initialization
	void Start () {
		zoomlevel = 3.5f;
		GameIsActive = false;

		sunrise = new Color (0.62f, 0.84f, 0.84f);
		sunset = new Color (0.0f, 0.0f, 0.0f);

		camera.backgroundColor = sunrise;

		//GS_ref = (GaiaScript)gaia_reference.GetComponent ("GaiaScript");

	}

	public void SetStartTime(float stime)
	{
		StartTime = stime;
	}

	public void StartGame()
	{
		GameIsActive = true;

		AudioSource as_reference = (AudioSource)GetComponent ("AudioSource");
		as_reference.PlayScheduled (0);

	}
	
	// Update is called once per frame
	void Update () {

		if (GameIsActive)
		{
			// TODO smooth this out later
			Vector3 FollowPos = Follow.transform.position;
			FollowPos.y += zoomlevel;
			transform.position = FollowPos;

			//zoomlevel += 0.005f;
			if(FollowPos.y < 680.0f)
				zoomlevel += (zoomlevel * 0.0005f * Time.timeScale);
			else
			{
				zoomlevel += 0.001f;
			}



			if(Time.time - StartTime > 60.0f)
			{
				Color bgRenderColor = new Color (
				((sunrise.r * (1.0f - ((Time.time - StartTime - 60.0f) / 120.0f))) + (sunset.r * (Time.time - StartTime - 60.0f) / 120.0f)),
				((sunrise.g * (1.0f - ((Time.time - StartTime - 60.0f) / 120.0f))) + (sunset.g * (Time.time - StartTime - 60.0f) / 120.0f)),
				((sunrise.b * (1.0f - ((Time.time - StartTime - 60.0f) / 120.0f))) + (sunset.b * (Time.time - StartTime - 60.0f) / 120.0f))
				);

				camera.backgroundColor = bgRenderColor;
			}
		}
	}
}
