﻿using UnityEngine;
using System.Collections;

public class LifeScript : MonoBehaviour {


	float excitement;
	public bool touched;
	public bool animed;
	public GameObject GameControllerReference;
	bool stillAlive;
	public float StartTime;
	public GaiaScript GaiaRef;
	public bool soulmate;
	//float nextmove;

	// Use this for initialization
	void Start () {

		excitement = Random.value * 8.0f;
		//nextmove = 0.0f;
		touched = false;
		stillAlive = true;
		animed = false;
		//Debug.Log("Life created with excitement " + excitement);
		MeshRenderer MR_REF = (MeshRenderer)GetComponent("MeshRenderer");
		MR_REF.material.SetColor("_Color", new Color(0.4f, 0.4f, 0.4f));
		
	}

	public void SetStartTime(float stime)
	{
		StartTime = stime;
	}
	
	// Update is called once per frame
	void Update () {

		// cruisers
		if(stillAlive)
			rigidbody.AddForce (new Vector3 (excitement * (Random.value - 0.5f), 0.0f, excitement * (Random.value - 0.5f)));

		/* smartpeople 1
		if (nextmove <= Time.time)
		{
			rigidbody.velocity = new Vector3(excitement * (Random.value - 0.5f), 0.0f, excitement * (Random.value - 0.5f));
			//rigidbody.velocity.Set(1.0f, 0.0f, 1.0f);
			float temphold = Random.value;
			nextmove = Time.time + (temphold * 15.0f);
			Debug.Log("Velocity: " + rigidbody.velocity.x + "," + rigidbody.velocity.y + "," + rigidbody.velocity.z + "," +
			          " Next move in " + temphold * 15.0f);
		}
		*/

		if (Time.time - StartTime >= 180.0f)
		{
			MeshRenderer MR_REF = (MeshRenderer)GetComponent ("MeshRenderer");


			if(Time.time - StartTime > 180.0f)
			{
				Color bgRenderColor = new Color (
					((0.4f * (1.0f - ((Time.time - StartTime - 180.0f) / 5.0f))) + (0.15f * (Time.time - StartTime - 180.0f) / 5.0f)),
					((0.4f * (1.0f - ((Time.time - StartTime - 180.0f) / 5.0f))) + (0.15f * (Time.time - StartTime - 180.0f) / 5.0f)),
					((0.4f * (1.0f - ((Time.time - StartTime - 180.0f) / 5.0f))) + (0.176f * (Time.time - StartTime - 180.0f) / 5.0f))
				);
				
				MR_REF.material.SetColor ("_Color", bgRenderColor);
			}
		}

		if(stillAlive)
		{
			if (Time.time - StartTime >= 185.0f)
			{

				stillAlive = false;
				rigidbody.velocity = new Vector3( 0.0f, 0.0f, 0.0f);
				//Debug.Log("Done Moving! Velocity: " + rigidbody.velocity.x + "," + rigidbody.velocity.y + "," + rigidbody.velocity.z);
			}
		}

		if(touched)
		{
			if(!animed)
			{
				ParticleSystem psref = (ParticleSystem)GetComponent("ParticleSystem");
				psref.Play();
				animed = true;
			}
		}

	}

	void OnTriggerEnter(Collider col)
	{
		//Debug.Log("!!!");
		if(!touched)
		{
			if(col.gameObject.name == "Player")
			{
				//Debug.Log("Player Touched!");
				touched = true;
				TrailRenderer setTR = (TrailRenderer)GetComponent("TrailRenderer");

				setTR.time = 180;

				MeshRenderer MR_REF = (MeshRenderer)GetComponent("MeshRenderer");
				MR_REF.material.SetColor("_Color", new Color(0.4f, 0.84f, 1.0f));

				GaiaRef.livesTouched ++;
				if(soulmate)
				{
					GaiaRef.soulmatefound = true;
				}
			}
		}

		if(col.gameObject.name == "Life(Clone)")
		{
			LifeScript other = (LifeScript)col.GetComponent("LifeScript");
			if(touched && !other.touched)
			{
				//Debug.Log("Touch sent");
				other.touched = true;
				TrailRenderer setTR = (TrailRenderer)col.GetComponent("TrailRenderer");
				setTR.time = 180;

				MeshRenderer MR_REF = (MeshRenderer)col.GetComponent("MeshRenderer");
				MR_REF.material.SetColor("_Color", new Color(0.4f, 0.84f, 1.0f));

				GaiaRef.memories++;

			}
			else if(!touched && other.touched)
			{
				//Debug.Log("Touch received");
				touched = true;
				TrailRenderer setTR = (TrailRenderer)GetComponent("TrailRenderer");
				setTR.time = 180;

				MeshRenderer MR_REF = (MeshRenderer)GetComponent("MeshRenderer");
				MR_REF.material.SetColor("_Color", new Color(0.4f, 0.84f, 1.0f));

				GaiaRef.memories++;

			}
		}
	}


}
