﻿using UnityEngine;
using System.Collections;

public class PlayerScript : MonoBehaviour {

	float mouseX;
	float mouseY;
	public float CheatSetTimeScale;
	bool gameplay;
	public float StartTime;
	public GaiaScript GaiaRef;
	public ParticleSystem psref;
	
	// Use this for initialization
	void Start () {

		CheatSetTimeScale = 1.0f;

		psref = (ParticleSystem)GetComponent ("ParticleSystem");
	
	}
	
	// Update is called once per frame
	void Update () {

		Time.timeScale = CheatSetTimeScale;

		if(gameplay)
		{
			if (Time.time - StartTime <= 180.0f)
			{
				
				if (Input.GetMouseButton (0)) 
				{

					Vector3 controlsv2 = new Vector3(Input.mousePosition.x - Screen.width/2, 0.0f, Input.mousePosition.y - Screen.height/2);
					controlsv2.Normalize();

					controlsv2.Scale(new Vector3(7.5f, 0.0f, 7.5f));
					//Debug.Log("ControlVector:" + controlsv2.x + " " +controlsv2.y + " " + controlsv2.z);
					rigidbody.velocity = controlsv2;

					/*
					mouseX = (Input.mousePosition.x - Screen.width/2) / Screen.width;
					if(mouseX > 0.25f)
						mouseX = 0.25f;
					if(mouseX < -0.25f)
						mouseX = -0.25f;


					mouseY = (Input.mousePosition.y - Screen.height/2 ) / Screen.height;

					if(mouseY > 0.25f)
						mouseY = 0.25f;
					if(mouseY < -0.25f)
						mouseY = -0.25f;

					rigidbody.velocity = new Vector3 (mouseX * 15.0f, 0.0f, mouseY * 15.0f);
					*/


				}
				else
				{
					rigidbody.velocity = Vector3.Scale(new Vector3(0.9f, 1.0f, 0.9f), rigidbody.velocity);
				}
			}
			else
			{
				rigidbody.velocity = new Vector3 (0,0,0);
				gameplay = false;
				GaiaScript gsref = (GaiaScript)GaiaRef.GetComponent("GaiaScript");
				gsref.gameSequence = 3;
				gsref.twittertime = Time.time;
			}


		}

		if(Input.GetKeyDown (KeyCode.Escape))
		{
			Application.Quit();
		}
	}

	public void GameStart()
	{
		gameplay = true;
		StartTime = Time.time;

		psref.Stop ();
		psref.Play ();
	}
}
